declare const _default: import("@postgresql-typed/util").PgTExtension<PgTCacheOptions>;
export default _default;
export interface PgTCacheOptions {
    /**
     * The connection string URI.
     */
    uri?: string;
    /**
     * The namespace to use for the cache.
     *
     * @default "pgt"
     */
    namespace?: string;
    /**
     * The TTL for the cache.
     *
     * Set to `0` to disable TTL.
     *
     * @default 1000 * 60 * 15 // (15 minutes)
     */
    ttl?: number;
    /**
     * The types of queries to cache.
     *
     * @default ["select"]
     */
    types?: ("select" | "insert" | "update" | "delete")[];
}
